



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>简单的STM32 汇编程序—闪烁LED</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">简单的STM32 汇编程序—闪烁LED</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 16:45:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>要移植操作系统，汇编是道不得不跨过去的坎。所以承接上篇的思路，我准备用汇编写一个简单的闪烁LED灯的程式。以此练习汇编，为操作系统做准备。</p>
<p><strong>第一步，还是和上篇一样，建立一个空的文件夹。 </strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/401655/201510/401655-20151008133450721-519406725.png" /></p>
<p><strong>第二步，因为是要用汇编来写程式，所以不需要启动代码，这里选择否。 </strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/401655/201510/401655-20151008133451378-1802507655.png" /></p>
<p><strong>第三步，建立一个.s文件，并把文件添加到工程中。 </strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/401655/201510/401655-20151008133451721-1751535499.png" /></p>
<p><strong>第四步，在LED.s文件中添加如下代码。 </strong></p>
<div>
<pre class="prettyprint linenums">LED0 EQU 0x422101a0<br />
RCC_APB2ENR EQU 0x40021018<br />
GPIOA_CRH EQU 0x40010804

Stack_Size      EQU     0x00000400

                AREA    STACK, NOINIT, READWRITE, ALIGN=<br />
Stack_Mem       SPACE   Stack_Size<br />
__initial_sp

                AREA    RESET, DATA, READONLY

__Vectors       DCD     __initial_sp               ; Top of Stack<br />
                DCD     Reset_Handler              ; Reset Handler

                AREA    |.text|, CODE, READONLY

                THUMB<br />
                REQUIRE8<br />
                PRESERVE8

                ENTRY<br />
Reset_Handler<br />
                BL LED_Init<br />
MainLoop        BL LED_ON<br />
                BL Delay<br />
                BL LED_OFF<br />
                BL Delay

                B MainLoop

LED_Init<br />
                PUSH {R0,R1, LR}

                LDR R0,=RCC_APB2ENR<br />
                ORR R0,R0,#0x04<br />
                LDR R1,=RCC_APB2ENR<br />
                STR R0,[R1]

                LDR R0,=GPIOA_CRH<br />
                BIC R0,R0,#0x0F<br />
                LDR R1,=GPIOA_CRH<br />
                STR R0,[R1]

                LDR R0,=GPIOA_CRH<br />
                ORR R0,R0,#0x03<br />
                LDR R1,=GPIOA_CRH<br />
                STR R0,[R1]

                MOV R0,#<br />
                LDR R1,=LED0<br />
                STR R0,[R1]

                POP {R0,R1,PC}

LED_ON<br />
                PUSH {R0,R1, LR}    

                MOV R0,#<br />
                LDR R1,=LED0<br />
                STR R0,[R1]

                POP {R0,R1,PC}

LED_OFF<br />
                PUSH {R0,R1, LR}    

                MOV R0,#<br />
                LDR R1,=LED0<br />
                STR R0,[R1]

                POP {R0,R1,PC}             

Delay<br />
                PUSH {R0,R1, LR}

                MOVS R0,#<br />
                MOVS R1,#<br />
                MOVS R2,#

DelayLoop0<br />
                ADDS R0,R0,#

                CMP R0,#<br />
                BCC DelayLoop0

                MOVS R0,#<br />
                ADDS R1,R1,#<br />
                CMP R1,#<br />
                BCC DelayLoop0

                MOVS R0,#<br />
                MOVS R1,#<br />
                ADDS R2,R2,#<br />
                CMP R2,#<br />
                BCC DelayLoop0

                POP {R0,R1,PC}    

    ;         NOP<br />
             END
</pre>
</div>
<p>///////////////////////////////////////////////////////</p>
<p>代码的简单讲解</p>
<p><strong>1，预定义 </strong></p>
<p>LED0 EQU 0x422101a0 ;PA8的Bit-Bond地址。</p>
<p>RCC_APB2ENR EQU 0x40021018</p>
<p>GPIOA_CRH EQU 0x40010804</p>
<p>为方便操作，给每个需要用到的寄存器地址定义一个名字，类似于C语言的#define。PA8的Bit-Bond地址的计算方法可按上篇文章中C语言的算法算出。后面的两个地址时固定的，可从STM32的手册查询，或者根据ST官方的库文件查找计算。</p>
<p><strong>2，分配栈空间 </strong></p>
<p>Stack_Size EQU 0x00000400</p>
<p>AREA STACK, NOINIT, READWRITE, ALIGN=3</p>
<p><em>Stack_Mem SPACE Stack_Size </em></p>
<p>__initial_sp</p>
<p>这一段摘自启动文件。要读懂这段代码，首先要了解两个命令。</p>
<p><strong>AREA命令</strong>：AREA 命令指示汇编器汇编一个新的代码段或数据段。段是独立的、指定的、不可见的代码或数据块，它们由链接器处理。格式如下：</p>
<p>AREA 段名，段属性1，段属性2，段属性3。。。</p>
<p><em>AREA STACK, NOINIT, READWRITE, ALIGN=3 </em></p>
<p><em>NOINIT： = NO Init，不初始化。 </em></p>
<p><em>READWRITE : 可读，可写。 </em></p>
<p><em>ALIGN =3 : 2^3 对齐，即8字节对齐。 </em></p>
<p><strong>SPACE命令：</strong>SPACE 命令保留一个用零填充的存储器块。</p>
<p>所以整段的意思为：分配一个STACK段，该段不初始化，可读写，按8字节对齐。分配一个大小为Stack_Size的存储空间，并使栈顶的地址为__initial_sp。</p>
<p><strong>3，分配向量表 </strong></p>
<p>AREA RESET, DATA, READONLY</p>
<p>__Vectors DCD __initial_sp ; Top of Stack</p>
<p>DCD Reset_Handler ; Reset Handler</p>
<p>这里的向量可参考我之前写的《<a href="http://www.cnblogs.com/WeyneChen/p/4846189.html" rel="external nofollow noreferrer">STM32向量表详细分析</a>》。</p>
<p><strong>4，开始代码段</strong></p>
<p>AREA |.text|, CODE, READONLY</p>
<p>通知汇编器，开始代码段。</p>
<p>THUMB</p>
<p>REQUIRE8</p>
<p>PRESERVE8</p>
<p>这段的意思是，汇编器支持THUMB指令，代码段按8字节对齐。</p>
<p><strong>ENTRY</strong>命令：声明整个程式的入口点，入口点有且仅有一个。不管哪种语言，编译器都得有个入口点，这没什么好说的。</p>
<p><strong>5，程序正式开始。 </strong></p>
<p>后面的代码，皆用标准的THUMB2汇编指令。首先了解下代码中用到的指令。</p>
<p><strong>BL</strong>：带链接的跳转指令。当使用该指令跳转时，当前地址(PC)会自动送入LR寄存器。</p>
<p><strong>B</strong>:无条件跳转。</p>
<p><strong>PUSH和POP</strong>：可以看到，所有的子程序都是由PUSH和POP包起来的。借用一张图解释下这两个指令。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/401655/201510/401655-20151008133452581-1027742092.png" /></p>
<p>据上可知，PUSH {R0,R1, LR}的意思即把R0,R1,LR中的值放入堆栈中。由于主程式中使用BL跳转指令，所以LR中的值实际上就是当前PC的值。而POP {R0,R1,PC}的意思即是将栈中之前存的R0，R1，LR的值返还给R0，R1，PC。这样就完成了子程序的返回。</p>
<p><strong>LDR和STR</strong>：寄存器的装载和存储指令。</p>
<p>LDR是把地址装载到寄存器中(比如R0)。</p>
<p>STR是把值存储到寄存器所指的地址中。</p>
<p>举个例子：</p>
<p>MOV R0,#1 ;将立即数1送入R0.</p>
<p>LDR R1,=LED0；将PA8 bit-bond的地址送入R1.</p>
<p>STR R0,[R1]；将R0的值，也就是1，送给R1中的值所指向的地址中，也就是PA8的bit-bond地址。</p>
<p>上面三句话的意思即是将PA8置1。</p>
<p><strong>ORR和BIC： </strong></p>
<p>ORR 按位或操作。ORR R0,R0,#0x04意思即将R0中的数或上0x04，再将结果送往R0中。实际意思就是将R0的第二位置1，其他位不变。</p>
<p>BIC 先把立即数取反，再按位与。</p>
<p><strong>CMP和BCC</strong>：CMP是比较两个数，相等或大于则将标志位C置位，否则将C清零。BCC是个组合指令，实际为B+CC，意思是如果C=0则跳转。</p>
<p>CMP R2,#15; 计算R2-15的值，若是R2&lt;15，则C=0；若是R2&gt;=15，则C=1。</p>
<p>BCC DelayLoop0；若是C=0，则跳到DelayLoop0，若是c=1，则不跳转。</p>
<p>以上就是代码段相关指令的介绍，相信了解了这些指令的含义，要理解代码并不困难。</p>
<p>整个代码的结构和上篇用C语言写的基本是一样的。可参照理解</p>
<p>////////////////////////////////////////////////////</p>
<p><strong>第五步，编译，下载。</strong></p>
<p>编译后，会有一个警告 No section matches pattern&hellip;&hellip;可不用管。下载后，LED灯正常闪烁。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jdvzw9.html">【原创】Kakfa api包源代码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq43op08.html">Spring4学习笔记1-HelloWorld与IOC和DI概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwgd4l8.html">&lpar;String&rpar; 压缩String</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oe72e9.html">用httpclient访问时，附带cookie信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgnl09.html">Oracle11G 卸载步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g61j9.html">JBoss EAP6&sol;AS7&sol;WildFly&colon; How to Use Properties Files Outside Your Archive--reference</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjlonr8.html">几种主流浏览器内置http抓包工具软件使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jv1l38.html">sed进阶N&semi;P&semi;D</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n65oq.html">ffmpeg转码使用硬件加速</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojworxq.html">SQL游标使用及实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j100v8.html">C&num; 异步转同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j40px8.html">jmeter在linux服务器的安装和运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwz5yx9.html">mac中安装 RabbitMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyokzxq.html">Git的上传步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyx7ngq.html">安卓创始人计划推出能帮你约会的AI手机</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwy33d8.html">CodeMirror  使用大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ppkkeq.html">sublime sftp注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e7y5g9.html">opengl学习笔记（三）&colon;经过纹理贴图的棋盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl5j4z9.html">批量生成反色图片，用PHOTOSHOP批处理功能。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn55e2q.html">DevExpress v17&period;2新版亮点&mdash;Bootstrap篇（一）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rnm07q.html">用javascript插入样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963gln9.html">《InsideUE4》UObject（一）开篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ko4yrq.html">c&plus;&plus;适配器</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2knlxq.html">洛谷P1782 旅行商的背包&lbrack;多重背包&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx2r308.html">洛谷P1991无线通讯网&lbrack;kruskal &vert; 二分答案 并查集&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql1do09.html">第22章  java线程&lpar;2&rpar;-线程同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ko653q.html">第3章 Linux常用命令（5）&lowbar;网络命令和挂载命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdj4oxq.html">U3D笔记11&colon;47 2016&sol;11&sol;30-15&colon;15 2016&sol;12&sol;19</a>
			</li>
						<li><a href="https://www.batexi.com/a/3902x4jq.html">bench&period;sh 跑分测速</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql14619.html">silverlight 4&period;0 的oob模式下，调用com通过wmi重启自身进程 killself</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
